#----------------------------------------------------------------------------------
#---- R function to compute Power and Robustness of single-SNP analysis -----------
#----------------------------------------------------------------------------------

#------------------ Load source --------------------------------------------------
source(file="fonctions/RobPower.r")
source(file="fonctions/recupA.r")

#------Recuperation de la matrice de parente -----------------------------

Afull = read.table(file="Matrice_A.txt",header=FALSE)
creation = recupA(fileped="Choix_A.txt",Afull)
A = creation[[1]]
D = creation[[2]]


# -------------Exemple 1: ---Visualisation risque premiere espèce

RobPower(A,D,h2=seq(0.1,0.9,0.1),threshold=0.05,var.QTL=c(0.01),methods=c("reg","grammar"),GC=FALSE,r2=1)

ex<-RobPower(A,D,h2=seq(0.1,0.9,0.1),threshold=0.05,var.QTL=c(0.01),methods=c("reg","grammar"),GC=FALSE,r2=1)

#------------------ Figure ------------------------------------------------

hh<-ex$regression$Robustness[1:9]
type_1_errorr<-ex$regression$Robustness[10:18]
type_1_errorg<-ex$grammar$Robustness[10:18]
fdr<-matrix(c(type_1_errorr,type_1_errorg),nrow=9)
matplot(hh,fdr, type="l")
abline(h=0.05,col="pink")


#------------------ Example 2 -Calcul de la puissance---------------------------------------------------
#avec 2 QTL : 1% 5%


seuil<-c(0.0000026,0.000013,0.000026,0.01,0.05,0.10)
dl<-c(0.2,0.8,1.0)
result<-matrix(0,nrow=length(seuil),ncol=2*length(dl))

#Boucle sur les seuils

for (i in 1:6) {
#Boucle sur le dl
for (j in 1:3) {

ex<-RobPower(A,D,h2=0.85,threshold=seuil[i],var.QTL=c(0.01,0.05),methods="fasta",GC=FALSE,r2=dl[j])
result[i,c(j*2-1,j*2)]<-ex$fasta$power[1:2]

}}

result


