#!/bin/bash
# Boucle du lancement blupf90 ou remlf90
#________________________________________________________
#
#     PARAMETRES
#_________________________________________________________


REPERTOIRE=/prodanr/aricard/Cours   # repertoire local ou sont actuellement les fichiers et programmes
PERFO=sim_ped_perf_mean             # fichier performance
GENOTYPE=genotypes1.uga             # fichier genotype ou Repertoire pour phases
GENEALOGIE=genealogie               # Fichier genealogie
VY=33.2113080                       # variance phenotypique
H2=0.85                             # heritabilite
MANQUANT=5                          # code genotype manquant
SNPMIN=1                            # numero du premier SNP traite 
SNPMAX=100                        # numero du dernier SNP traite 
SOLUTION=solution                   # Nom du fichiers de solution
REPERTOIREW=$REPERTOIRE/work        #repertoire de travail temporaire
ASREML=snp                          # nom temporaire des fichiers de donnees
GENOTYPEB=${GENOTYPE}bis            # nom du fichiers des genotpes exploitables (pour Muller)

#________________________________________________________
#
#     DEBUT
#_________________________________________________________



# Agregation variables 

SNPMINMAX=$SNPMIN"  "$SNPMAX

# Constantes
   REPET=$H2
   echo '------------------------------'
   echo 'CALCUL DES PARAMETRES UTILES '
   echo '------------------------------'
   LANDA=`expr "scale=6;(1-$REPET)/$H2" | bc `
   echo "parametre landa "$LANDA

#  Calcul des composantes

   compo=`expr "scale=6;1/$LANDA" | bc `
   echo "parametre compo" $compo
   ve=`expr "scale=6;(1-$REPET)*$VY" | bc `
   echo "variance residuelle  "$ve
   va=`expr "scale=6;$H2*$VY" | bc `
   echo "variance genetique "$va
   vtest=`expr "scale=6;0.02*$VY" | bc `
   echo "variance test "$vtest

# nombre d animaux


animaux=$(cat $GENEALOGIE | wc -l)
echo "animaux   $animaux"


perfo=$(cat $PERFO | wc -l)
echo "performeurs   $perfo"


#Creation repertoire de travail

# Effacement de l'ancien repertoire

if  [ -d $REPERTOIREW ]
then
  rm -r $REPERTOIREW
fi

mkdir $REPERTOIREW

# copie du fichier de genealogie

 cp $REPERTOIRE/$GENEALOGIE $REPERTOIREW/$GENEALOGIE 



# Effacement des anciens fichiers parametres et genotypes bis

if  [ -f parmp ]
then
  rm parmp
  rm parml 
fi

if  [ -f $GENOTYPEB ]
then
  rm $GENOTYPEB
fi


# Calcul du nombre de SNP dans le fichier de genotypage


  LSNP=$(awk 'NR == 1 {print length($2)}' $REPERTOIRE/$GENOTYPE)
echo "Nombre de SNP dans le fichier genotype "$LSNP

if [ $SNPMIN -eq "0" ]
then 
  SNPMIN=1
  SNPMAX=$LSNP
fi


#Ecriture du fichier parametre parm_regmod1

 echo "'${REPERTOIRE}/$PERFO'" >> parmp
 echo "'$REPERTOIRE/$GENOTYPE'" >> parmp
 echo "'$GENEALOGIE'" >> parmp
 echo "'$REPERTOIREW'">> parmp
 echo "'$REPERTOIRE'">> parmp
 echo "'$ASREML'" >> parmp
 echo  "$MANQUANT" >> parmp
 echo  "$SNPMINMAX" >> parmp  
 echo "$va" >> parmp
 echo "$ve" >> parmp
 echo "$animaux" >> parmp
 echo "$LSNP" >> parmp


#Ecriture du fichier parametre regmod2 pour reg_modblup2



 echo "'$REPERTOIREW'" >> parml 
 echo "'$ASREML'" >> parml
 echo "'$REPERTOIREW/$SOLUTION'" >> parml
 echo  "$SNPMINMAX" >> parml
 echo "$perfo" >> parml




# Lancement de l ecriture des fichiers de donnees par SNP 


$REPERTOIRE/bin/preparation < parmp



# Lancement du qarray pour traiter tous les SNP

cd $REPERTOIREW

qarray -sync y mes_commandes.txt

# Ecriture des solutions


  echo "ecriture des resultats  "

# Lancement de la lecture des solutions 

cd $REPERTOIRE

$REPERTOIRE/bin/lecture < parml


cp $REPERTOIREW/$SOLUTION $REPERTOIRE/$SOLUTION 

  echo "fin de la chaine  "











